using System;
using System.Drawing;
using System.Windows.Forms;


namespace Sample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Sample1Form : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button SetRigButton;
		private System.Windows.Forms.TextBox FreqBox;
		private System.Windows.Forms.ComboBox ModeBox;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Sample1Form()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.FreqBox = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.SetRigButton = new System.Windows.Forms.Button();
			this.ModeBox = new System.Windows.Forms.ComboBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(96, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Frequency in MHz";
			// 
			// FreqBox
			// 
			this.FreqBox.Location = new System.Drawing.Point(120, 24);
			this.FreqBox.Name = "FreqBox";
			this.FreqBox.Size = new System.Drawing.Size(88, 20);
			this.FreqBox.TabIndex = 1;
			this.FreqBox.Text = "";
			this.FreqBox.TextChanged += new System.EventHandler(this.FreqBox_TextChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(72, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(32, 23);
			this.label2.TabIndex = 2;
			this.label2.Text = "Mode";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// SetRigButton
			// 
			this.SetRigButton.Location = new System.Drawing.Point(112, 104);
			this.SetRigButton.Name = "SetRigButton";
			this.SetRigButton.TabIndex = 4;
			this.SetRigButton.Text = "Set Rig";
			this.SetRigButton.Click += new System.EventHandler(this.SetRigButton_Click);
			// 
			// ModeBox
			// 
			this.ModeBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.ModeBox.ItemHeight = 13;
			this.ModeBox.Items.AddRange(new object[] {
														 "CW",
														 "LSB",
														 "USB",
														 "FM",
														 "AM",
														 "RTTY"});
			this.ModeBox.Location = new System.Drawing.Point(120, 64);
			this.ModeBox.Name = "ModeBox";
			this.ModeBox.Size = new System.Drawing.Size(88, 21);
			this.ModeBox.TabIndex = 3;
			this.ModeBox.SelectedIndexChanged += new System.EventHandler(this.ModeBox_SelectedIndexChanged);
			// 
			// Sample1Form
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 142);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.SetRigButton,
																		  this.ModeBox,
																		  this.label2,
																		  this.FreqBox,
																		  this.label1});
			this.Name = "Sample1Form";
			this.Text = "Set Rig Frequency and Mode";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Sample1Form());
		}
		
		//Connect to AA6YQ's CI-V Commander program and set the users radio to the
		// given frequency and mode. Called by SetRigButton_Click
		public bool DDESetRig( string Freq, string Mode)
		{
			uint ddeInst = 0; // The DDE conversation instance
			uint hszService = 0; // DDE String handle for the service
			uint hszTopic = 0; // DDE String handle for the topic
			string Service = "CI-V Commander"; // Service name
			string Topic = "DDEServer"; // Topic name
			string data = String.Empty; // Holds the command string
			string lf = String.Empty; // Length of the Freq parameter
			string mf = String.Empty; // Length of the Mode parameter
			uint htransaction = 0; // Result code from DdeClientTransaction
			int DataLen = 0; // Length of the command data string
			uint hConv = 0; // The DDE Conversation handle
			uint res = 0; // Captures retrned results
			uint zero = 0; // Dummy referred to when we need to ref a zero value
			bool success = true; // Sucess or fail flag
			
			// Get a conversasion handle
			if((res = Win32API.User.DdeInitialize(ref ddeInst,ref zero,Win32API.User.APPCMD_CLIENTONLY,0)) != 0)
			{
				success = false; // This should never happen
			}
			// Convert the Service and Topic names to DDE string handles.
			// We need to free these when we ard done
			hszService = Win32API.User.DdeCreateStringHandle( ddeInst, Service , Win32API.User.CP_WINANSI );
			hszTopic = Win32API.User.DdeCreateStringHandle( ddeInst, Topic , Win32API.User.CP_WINANSI );
			if( hszService == 0 || hszTopic == 0)
			{
				success = false; // This should never happen
			}

			// Connect to CI-V Commander
			if((hConv = Win32API.User.DdeConnect( ddeInst, hszService, hszTopic, ref zero)) == 0)
			{
				success = false; // This will happen if Commander doesn't accept the connection
			}
			if(FreqBox.Text != String.Empty && ModeBox.Text != String.Empty) // If these are empty just check to see if Commander is alive
			{

				// Send the command string
				lf = Freq.Length.ToString();
				mf = Mode.Length.ToString();
				
				// Assemble the command string
				data = "000xcvrfreqmode<xcvrfreq:" + lf + ">" + Freq + "<xcvrmode:" + mf + ">" + Mode;
				DataLen = data.Length + 1; // +1 because DDE wants to see the string terminating \0

				// Set the Frequency and Mode of the radio
				if((res = Win32API.User.DdeClientTransaction( data, DataLen, hConv, 0, 0,
					Win32API.User.XTYP_EXECUTE, Win32API.User.TIMEOUT_ASYNC, ref htransaction)) == 0)
				{
					success = false; // This will happen if commander doesn't accept the command
				}
			}
			if(hConv != 0)
			{
				Win32API.User.DdeDisconnect(ddeInst);
			}
			// Clean up and go home
			Win32API.User.DdeUninitialize(ddeInst);
			ddeInst = 0;
			hszService = 0;
			hszTopic = 0;
			hConv = 0;
			return success; // Hopefully == true 
		}


		private void SetRigButton_Click(object sender, System.EventArgs e)
		{
			string khz;
			float frq = 0;
			if(FreqBox.Text == String.Empty || ModeBox.Text == String.Empty)
			{
				string msg = "No Frequency or Mode Specified";
				MessageBox.Show(msg,"Sample1 Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;

			}
			try
			{
				frq = Convert.ToSingle(FreqBox.Text) * 1000;
			}
			catch
			{
				string msg = "Frequency contains non-numeric characters";
				MessageBox.Show(msg,"Sample1 Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;

			}
			khz = frq.ToString();

			if(DDESetRig(khz, ModeBox.Text) != true)
			{
				string msg = "Failed connection to Commander. Please make sure it is running and that the frequency and mode are in the correct format";
				MessageBox.Show(msg,"Sample1 Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void FreqBox_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void ModeBox_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}
	}
}
